schedule function bastion_raid:10t 10t

#SPAWN CAPTAIN WITHER SKELETON 10% CHANCE
execute as @e[type=wither_skeleton,tag=!smithed.entity,tag=!smithed.strict,tag=!bastion_raid.tagged,predicate=bastion_raid:chance_10,predicate=bastion_raid:location/fortress] at @s run execute unless entity @a[gamemode=!spectator,distance=..8] run function summon:bastion_raid/captain
tag @e[type=wither_skeleton,tag=!bastion_raid.tagged,tag=!smithed.entity,tag=!smithed.strict] add bastion_raid.tagged

#APPLY STRENGTH TO RAIDERS TARGETTING TARGET
effect give @e[type=wither_skeleton,tag=bastion_raid.raider,predicate=bastion_raid:angryat/piglin] strength 1 2 true

#DISPLAY ALLIES REMAINING
scoreboard players reset bastion_raid.sc bastion_raid.aly
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute store result score bastion_raid.sc bastion_raid.aly run execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target]
execute if score bastion_raid.sc bastion_raid.vis matches 1 run title @a[scores={bastion_raid.mem=1}] actionbar [{"text": "Allies Remaining : ","bold": true,"color": "green"},{"score":{"name": "bastion_raid.sc","objective": "bastion_raid.aly"},"bold": true,"color": "white"}]

#NUMBER OF RAIDERS
scoreboard players reset bastion_raid.sc bastion_raid.num
execute if entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target] run execute store result score bastion_raid.sc bastion_raid.num run execute if entity @e[type=wither_skeleton,tag=bastion_raid.raider]
execute if score bastion_raid.sc bastion_raid.num matches 2 run bossbar set bastion_raid:raid name [{"text": "Raid - Raiders Remaining: 2"}]
execute if score bastion_raid.sc bastion_raid.num matches 1 run bossbar set bastion_raid:raid name [{"text": "Raid - Raiders Remaining: 1"}]
execute if score bastion_raid.sc bastion_raid.num matches 2 run effect give @e[type=wither_skeleton,tag=bastion_raid.raider] glowing 1 0 true
execute if score bastion_raid.sc bastion_raid.num matches 1 run effect give @e[type=wither_skeleton,tag=bastion_raid.raider] glowing 1 0 true

#TAG PIGLIN BRUTE BASTION_RAID.BRUTE
tag @e[type=piglin_brute,tag=!smithed.entity,tag=!bastion_raid.brute] add bastion_raid.brute

#PIGLIN BRUTE SOUND
execute as @e[type=piglin,tag=bastion_raid.brute,predicate=bastion_raid:chance_25] at @s run playsound entity.piglin_brute.ambient hostile @a ~ ~ ~
execute as @e[type=piglin,tag=bastion_raid.brute,predicate=bastion_raid:chance_10,predicate=bastion_raid:angry] at @s run playsound entity.piglin_brute.angry hostile @a ~ ~ ~
execute as @e[type=piglin,tag=bastion_raid.brute,nbt={HurtTime:9s}] at @s run playsound entity.piglin_brute.hurt hostile @a ~ ~ ~

#RAID - DEFEAT
execute if score bastion_raid.sc bastion_raid.vis matches 1 run execute as @e[type=area_effect_cloud,tag=bastion_raid.spawner] at @s run execute unless entity @e[type=#bastion_raid:piglins,tag=bastion_raid.target] run function bastion_raid:raid/defeat

#RE-ADD THE CAPTAIN TAG TO CAPTAIN WITHER SKELETON
execute unless score bastion_raid.sc bastion_raid.vis matches 1 run tag @e[type=wither_skeleton,tag=bastion_raid.cpt,tag=!bastion_raid.captain] add bastion_raid.captain